unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Metastock, StdCtrls, ComCtrls, DirDlg;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    lvRates: TListView;
    edDirRead: TEdit;
    Button2: TButton;
    btnReadRates: TButton;
    lvStocks: TListView;
    Button5: TButton;
    edDirWrite: TEdit;
    Button6: TButton;
    MetastockImport1: TMetastockImport;
    MetastockExport1: TMetastockExport;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnReadRatesClick(Sender: TObject);
    procedure MetastockImport1StockRate(Sender: TObject; Date: TDateTime;
      Open, High, Low, Close, Volume: Double);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Dir: string;
begin
  Dir := edDirRead.Text;
  if SelectDirectory('Select Directory',edDirRead.Text,'',Dir) then
    edDirRead.Text := Dir;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  Dir: string;
begin
  Dir := edDirWrite.Text;
  if SelectDirectory('Select Directory',edDirWrite.Text,'',Dir) then
    edDirWrite.Text := Dir;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  edDirRead.Text := ExtractFilePath(Application.ExeName);
  edDirWrite.Text := 'c:\';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
begin
  MetastockImport1.Directory := edDirRead.Text;
  MetastockImport1.ReadMaster;
  for i := 0 to MetastockImport1.Count - 1 do begin
    with lvStocks.Items.Add do begin
      Caption := MetastockImport1[i].Symbol;
      SubItems.Add(MetastockImport1[i].Name);
      SubItems.Add(DateToStr(MetastockImport1[i].FirstDate));
      SubItems.Add(DateToStr(MetastockImport1[i].LastDate));
    end;
  end;
end;

procedure TForm1.btnReadRatesClick(Sender: TObject);
begin
  if lvStocks.Selected = Nil then
    Exit;
  lvRates.Items.Clear;
  lvRates.Items.BeginUpdate;
  MetastockImport1.ReadRates(lvStocks.Selected.Caption);
  lvRates.Items.EndUpdate;
end;

procedure TForm1.MetastockImport1StockRate(Sender: TObject;
  Date: TDateTime; Open, High, Low, Close, Volume: Double);
begin
  with lvRates.Items.Add do begin
    Caption := DateToStr(Date);
    SubItems.Add(FloatToStrF(Open,ffFixed,10,2));
    SubItems.Add(FloatToStrF(High,ffFixed,10,2));
    SubItems.Add(FloatToStrF(Low,ffFixed,10,2));
    SubItems.Add(FloatToStrF(Close,ffFixed,10,2));
    SubItems.Add(FloatToStrF(Volume,ffFixed,10,0));
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i,j: integer;
begin
  if edDirRead.Text = edDirWrite.Text then begin
    MessageDlg('Export directory can not be the same as Import',mtError,[mbOk],0);
    Exit;
  end;
  Screen.Cursor := crHourGlass;
  try
    MetastockExport1.Directory := edDirWrite.Text;
    MetastockExport1.BeginExport;
    for i := 0 to lvStocks.Items.Count - 1 do begin
      lvStocks.Items[i].Selected := True;
      btnReadRates.Click;
      MetastockExport1.BeginStock(lvStocks.Selected.Caption,lvStocks.Selected.SubItems[0],7);
      for j := 0 to lvRates.Items.Count - 1 do
        MetastockExport1.WriteRate(StrToDate(lvRates.Items[i].Caption),
                                   StrToFloat(lvRates.Items[i].SubItems[0]),
                                   StrToFloat(lvRates.Items[i].SubItems[1]),
                                   StrToFloat(lvRates.Items[i].SubItems[2]),
                                   StrToFloat(lvRates.Items[i].SubItems[3]),
                                   StrToFloat(lvRates.Items[i].SubItems[4]));
      MetastockExport1.EndStock;
    end;
    MetastockExport1.EndExport;
  finally
    Screen.Cursor := crDefault;
  end;
end;

end.
